/*
 * Copyright (C) 1999, 2000, 2001, 2002  Lorenzo Bettini, bettini@gnu.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef LINENOGEN_H
#define LINENOGEN_H

#include "decorators.h"

class LineNumberDecorator : public TextDecorator
{
 protected:
  static bool generated_newline;
  static unsigned int lineno;

  bool generate_ref;

  virtual void generate_lineno();

 public:
  LineNumberDecorator(TextGenerator *, CharTranslator *, bool gen_ref = false);

  virtual void generate( const char *s );
  virtual void generate_preproc(const char *s);
  virtual void generateln( const char *s );

  virtual void startDecorate();
  virtual void endDecorate() {}

  static void reset();
};

#endif // LINENOGEN_H
